SystemOrganization addCategory: #Trachel!

Announcement subclass: #TREvent
	instanceVariableNames: 'shape canvas position morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Trachel'!

!TREvent methodsFor: 'accessing' stamp: 'AlexandreBergel 12/15/2013 22:56'!
canvas
	
	^ canvas! !

!TREvent methodsFor: 'accessing' stamp: 'AlexandreBergel 12/15/2013 22:56'!
canvas: aTrachelCanvas
	
	canvas := aTrachelCanvas! !

!TREvent methodsFor: 'accessing' stamp: 'AlexandreBergel 12/18/2013 18:36'!
element
	"Could be any object"
	^ self shape element! !

!TREvent methodsFor: 'accessing' stamp: 'AlexandreBergel 12/23/2013 23:44'!
morph
	^ morph! !

!TREvent methodsFor: 'accessing' stamp: 'AlexandreBergel 12/16/2013 15:31'!
morph: aMorph
	morph := aMorph! !

!TREvent methodsFor: 'accessing' stamp: 'AlexandreBergel 12/15/2013 22:56'!
position
	
	^ position! !

!TREvent methodsFor: 'accessing' stamp: 'AlexandreBergel 12/15/2013 22:56'!
position: aPoint
	
	position := aPoint! !

!TREvent methodsFor: 'accessing' stamp: 'AlexandreBergel 12/15/2013 22:56'!
shape
	
	^ shape! !

!TREvent methodsFor: 'accessing' stamp: 'AlexandreBergel 12/15/2013 22:56'!
shape: aTrachelShape
	
	shape := aTrachelShape! !

!TREvent methodsFor: 'accessing' stamp: 'AlexandreBergel 12/16/2013 15:32'!
signalUpdate
	morph notNil ifTrue: [ morph changed ]
	! !

TREvent subclass: #TRMouseClick
	instanceVariableNames: 'commandKeyPressed controlKeyPressed shiftKeyPressed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Trachel'!

!TRMouseClick commentStamp: '' prior: 0!
A ROMouseClick is xxxxxxxxx.

Instance Variables
	commandKeyPressed:		<Object>
	controlKeyPressed:		<Object>
	shiftKeyPressed:		<Object>

commandKeyPressed
	- xxxxx

controlKeyPressed
	- xxxxx

shiftKeyPressed
	- xxxxx
!

!TRMouseClick methodsFor: 'accessing' stamp: 'AlexandreBergel 12/23/2013 19:08'!
commandKeyPressed
	^ commandKeyPressed! !

!TRMouseClick methodsFor: 'accessing' stamp: 'AlexandreBergel 12/23/2013 19:08'!
commandKeyPressed: anObject
	commandKeyPressed := anObject! !

!TRMouseClick methodsFor: 'accessing' stamp: 'AlexandreBergel 12/23/2013 19:08'!
controlKeyPressed
	^ controlKeyPressed! !

!TRMouseClick methodsFor: 'accessing' stamp: 'AlexandreBergel 12/23/2013 19:08'!
controlKeyPressed: anObject
	controlKeyPressed := anObject! !

!TRMouseClick methodsFor: 'accessing' stamp: 'AlexandreBergel 12/23/2013 19:08'!
initialize 
	super initialize.
	commandKeyPressed := false.
	controlKeyPressed := false.
	shiftKeyPressed := false.! !

!TRMouseClick methodsFor: 'accessing' stamp: 'AlexandreBergel 12/23/2013 19:08'!
shiftKeyPressed
	^ shiftKeyPressed! !

!TRMouseClick methodsFor: 'accessing' stamp: 'AlexandreBergel 12/23/2013 19:08'!
shiftKeyPressed: anObject
	shiftKeyPressed := anObject! !

TREvent subclass: #TRMouseDragging
	instanceVariableNames: 'step'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Trachel'!

!TRMouseDragging methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/16/2013 15:51'!
initialize
	super initialize.
	step := 0 @ 0! !

!TRMouseDragging methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/16/2013 15:51'!
step
	^ step! !

!TRMouseDragging methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/16/2013 15:51'!
step: aPoint
	step := aPoint! !

TREvent subclass: #TRMouseEnter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Trachel'!

TREvent subclass: #TRMouseLeave
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Trachel'!

TREvent subclass: #TRMouseMove
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Trachel'!

TestCase subclass: #TRCanvasTest
	instanceVariableNames: 'canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Trachel'!

!TRCanvasTest methodsFor: 'running' stamp: 'AlexandreBergel 12/14/2013 11:06'!
setUp

	canvas := TRCanvas new! !

!TRCanvasTest methodsFor: 'animations' stamp: 'AlexandreBergel 12/23/2013 17:50'!
testAddingAnimation
	canvas addAnimation: (RTLinearMove to: 50 @ 50 during: 2 on: RTBox element).
	self assert: canvas hasAnimation.
	self assert: canvas numberOfAnimations = 1! !

!TRCanvasTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/24/2013 15:47'!
testBox
	| rec box |
	rec := (50 @ 50 extent: 100 @ 50).
	box := canvas buildRectangle: rec color: Color purple.
	self assert: box rectangle center = rec center.

	box extent: 20 @ 20.
	self assert: box rectangle center = rec center.! !

!TRCanvasTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/25/2013 09:25'!
testCanvas
	| box |
	box := canvas buildRectangle: ( (5 @ 5) extent: (5 @ 5) ) color: Color red.
	self assert: box canvas == canvas.
	self assert: box athensCanvas == canvas athensCanvas.
	self assert: canvas ~~ canvas athensCanvas.! !

!TRCanvasTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/24/2013 18:39'!
testCircle

	| c  |
	c := TRCanvas new.
	100 to: 200 by: 20 do: [ :i |
		 c buildCircleFrom: 50 @ 50 to: i @ 100 color: (Color red alpha: 0.2).
	].
	self assert: c numberOfShapes = (100 to: 200 by: 20) size ! !

!TRCanvasTest methodsFor: 'contains' stamp: 'AlexandreBergel 12/15/2013 19:07'!
testContainsPoint1
	self assert: (canvas shapeForPosition: 20 @ 20) == canvas! !

!TRCanvasTest methodsFor: 'contains' stamp: 'AlexandreBergel 12/15/2013 19:17'!
testContainsPoint2
	| box |
	box := canvas buildRectangle: (15 @ 15 extent: 20 @ 20) color: Color gray.
	self assert: (canvas shapeForPosition: 20 @ 20) == box.
	self assert: (canvas shapeForPosition: 35 @ 35) == canvas.
	self assert: (canvas shapeForPosition: 15 @ 15) == box.
	self assert: (canvas shapeForPosition: 200 @ 200) == canvas.! !

!TRCanvasTest methodsFor: 'contains' stamp: 'AlexandreBergel 12/16/2013 16:14'!
testContainsPointAfterTranslation
	| box |
	box := canvas buildRectangle: (0 @ 0 extent: 20 @ 20) color: Color gray.

	box translateTo: 10 @ 10.
	
	self assert: (canvas shapeForPosition: 10 @ 10) == box.
	self assert: (canvas shapeForPosition: 5 @ 5) == canvas.
! !

!TRCanvasTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/14/2013 18:52'!
testDefault

	self assert: canvas shapes isEmpty! !

!TRCanvasTest methodsFor: 'animations' stamp: 'AlexandreBergel 12/18/2013 18:26'!
testDefaultAnimation
	self deny: canvas hasAnimation.
	self assert: canvas numberOfAnimations = 0! !

!TRCanvasTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/14/2013 18:51'!
testShape
	| shape |
	shape := canvas buildRectangle: (5 @ 5 extent: 20 @ 20) color: Color gray.
	self assert: shape notNil.
! !

!TRCanvasTest methodsFor: 'events' stamp: 'AlexandreBergel 12/15/2013 23:17'!
testShapeAndEvent
	| shape t |
	shape := TRBoxShape new.
	t := false.
	shape on: TRMouseEnter do: [ :event | t := true ].
	self deny: t.
	shape announce: TRMouseEnter new.
	self assert: t! !

!TRCanvasTest methodsFor: 'events' stamp: 'AlexandreBergel 12/16/2013 09:49'!
testShapeAndSharedAnnouncer
	| shape1 shape2 t |
	shape1 := TRBoxShape new.
	shape2 := TRLineShape new.
	shape1 announcer: shape2 announcer.
	
	t := 0.
	shape1 on: TRMouseLeave do: [ :event | t := t + 1 ].
	shape2 on: TRMouseEnter do: [ :event | t := t + 10 ].

	shape1 announce: TRMouseEnter new.
	shape2 announce: TRMouseLeave new.
	self assert: t = 11! !

!TRCanvasTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/14/2013 18:52'!
testShapes

	canvas buildRectangle: (5 @ 5 extent: 20 @ 20) color: Color gray.
	canvas buildRectangle: (5 @ 5 extent: 20 @ 20) color: Color gray.
	self assert: canvas shapes size = 2! !

Morph subclass: #TRMorph
	instanceVariableNames: 'trachelCanvas surface eventBeginingDragging shapeBeingPointed shouldRefresh'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Trachel'!

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/14/2013 10:29'!
canvas: aTrachelCanvas
	trachelCanvas := aTrachelCanvas.
	surface := AthensCairoSurface extent: aTrachelCanvas extent! !

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/17/2013 14:56'!
createSurface
	surface := AthensCairoSurface extent: self extent asIntegerPoint! !

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/23/2013 13:50'!
drawOn: aCanvas
	"aCanvas is a form canvas"

	aCanvas fillRectangle: bounds color: Color lightGray.
	
	trachelCanvas playAnimations.
	
	"The drawing has to be done when a change in the shapes occured or when there is an animation."
	surface drawDuring: [:cs |
		surface clear.		
		"cs pathTransform 
			scaleBy: 1.0."
		trachelCanvas shapes do: [ :trachelShape |
			trachelShape drawOn: cs.
		]
	].
	"aCanvas translucentImage: surface asForm at: self bounds origin."
	"asForm creates a new Form, which is likely to be expensive. This can be cached"
	aCanvas image: surface asForm at: self bounds origin sourceRect: (0 @ 0 extent: surface extent) rule: 34! !

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/15/2013 19:44'!
handleMouseMove: anEvent
	super handleMouseMove: anEvent.
	self rtMouseMoving: anEvent.! !

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/16/2013 15:45'!
handleMouseOver: anEvent

	| currentElement event |
	anEvent wasHandled ifTrue:[ ^ self ]. "not interested"
	"Do nothing if we are dragging"
	self isDragging ifTrue: [ ^ self ].
	 
	shapeBeingPointed ifNil: [ shapeBeingPointed := self shapeForEvent: anEvent ].
	
	currentElement := self shapeForEvent: anEvent.
	(currentElement ~~ shapeBeingPointed)
		ifTrue: [ 
			event := TRMouseLeave new.
			event morph: self.
			event position: (self relativePositionFor: anEvent).
			event shape: shapeBeingPointed.

			shapeBeingPointed announce: event.
			shapeBeingPointed := currentElement.
			self rtMouseEnter: anEvent ].
! !

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/15/2013 19:35'!
handlesMouseDown: anEvent
	anEvent wasHandled ifTrue:[ ^ false ]. "not interested"

	^ true! !

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/15/2013 19:34'!
handlesMouseOver: evt
	^ true! !

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/25/2013 08:30'!
initialize
	super initialize.
	self createSurface.
	shouldRefresh := false
	"session := Smalltalk session."! !

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/15/2013 19:46'!
isDragging
	^ eventBeginingDragging notNil! !

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/17/2013 14:55'!
layoutChanged 
	"react on morph resize"
	super layoutChanged.
	surface ifNotNil: [  
		self extent asIntegerPoint ~= surface extent ifTrue: [ 
			self createSurface ]
	].
	! !

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/16/2013 15:57'!
mouseDown: evt

	eventBeginingDragging ifNil: [
		evt hand 
					waitForClicksOrDrag: self 
					event: evt 
					selectors: { #rtMouseClick:. nil. nil. #rtMouseDragBegin: }
					threshold: 5.
		^ self ].
	
	evt anyButtonPressed ifTrue: [
		self rtMouseDragging: evt.
	].
	evt wasHandled: true.
	^ true! !

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/15/2013 23:08'!
mouseEnter: evt
	evt anyButtonPressed ifFalse: [
		self rtMouseEnter: evt.
	].
	evt wasHandled: true.
	^ true! !

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/15/2013 19:34'!
mouseLeave: evt
	
	evt anyButtonPressed ifFalse: [
		self rtMouseLeave: evt.
	].
	evt wasHandled: true.
	^ true! !

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/16/2013 15:58'!
mouseMove: evt
	
	evt anyButtonPressed
		ifTrue: [ self rtMouseDragging: evt ] 
		ifFalse: [ self rtMouseMoving: evt ].
	evt wasHandled: true.
	^ true! !

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/16/2013 16:05'!
mouseUp: evt
	self isDragging ifTrue: 
		[self rtMouseDragEnd: evt ].
	evt wasHandled: true.! !

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/15/2013 19:03'!
relativePositionFor: evt
	"Return the position within the window"
	
	^ evt position - self bounds origin! !

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/23/2013 23:45'!
rtMouseClick: evt
	| relativePosition ev  shape |
	relativePosition := self relativePositionFor: evt.	
"	evt yellowButtonChanged
		ifTrue: [ ev := TRMouseRightClick new ].
	evt redButtonChanged
		ifTrue: [ ev := TRMouseLeftClick new ].
	evt blueButtonChanged
		ifTrue: [ ev := TRMouseClick new ]."

	shape := self shapeForPosition: relativePosition.
	ev := TRMouseClick new.
	ev commandKeyPressed: evt commandKeyPressed.
	ev controlKeyPressed: evt controlKeyPressed.
	ev shiftKeyPressed: evt shiftPressed.
	ev shape: shape.
	ev morph: self.
	
	ev position: relativePosition.
	shape announce: ev.
	! !

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/16/2013 16:00'!
rtMouseDragBegin: evt
	| relativePosition |
	eventBeginingDragging := evt copy.
	
	relativePosition := self relativePositionFor: evt.
	shapeBeingPointed := self shapeForPosition: relativePosition! !

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/16/2013 16:05'!
rtMouseDragEnd: evt
	eventBeginingDragging := nil.
	shapeBeingPointed := nil! !

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/16/2013 16:00'!
rtMouseDragging: evt
	| step relativePosition event  |
	eventBeginingDragging ifNil: [ ^ self ].
	relativePosition := self relativePositionFor: evt.
	step := evt position - eventBeginingDragging position.

	shapeBeingPointed ifNil: 
		[ shapeBeingPointed := self shapeForPosition: relativePosition ].
	
	event := TRMouseDragging new 
				morph: self;
				shape: shapeBeingPointed;
				step: step; 
				yourself.

"	event commandKeyPressed: evt commandKeyPressed.
	event controlKeyPressed: evt controlKeyPressed.
	event shiftKeyPressed: evt shiftPressed.				
"
	event position: relativePosition.
	shapeBeingPointed announce: event.

	eventBeginingDragging := evt copy.! !

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/16/2013 15:30'!
rtMouseEnter: evt
	| relativePosition ev shape |
	
	relativePosition := self relativePositionFor: evt.

	shape := self shapeForPosition: relativePosition.
	ev := TRMouseEnter new.
	ev position: relativePosition.
	ev shape: shape.
	ev morph: self.
	shape announce: ev.
! !

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/16/2013 15:37'!
rtMouseLeave: evt
	| position ev shape |
	
	position := self relativePositionFor: evt.
	shape := self shapeForPosition: position.
Transcript show: shape printString; cr.
	ev := TRMouseLeave new.
	ev position: position.
	ev shape: shape.
	ev morph: self.
	shape announce: ev
! !

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/16/2013 15:27'!
rtMouseMoving: evt

	| relativePosition ev shape |
	relativePosition := self relativePositionFor: evt.	
	shape := self shapeForPosition: relativePosition.

	ev := TRMouseMove new.
	ev position: relativePosition.
	ev shape: shape.
	ev morph: self.
	(self shapeForPosition: relativePosition) announce: ev! !

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/15/2013 19:48'!
shapeForEvent: anEvent	
	^ self shapeForPosition: (self relativePositionFor: anEvent)! !

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/15/2013 19:07'!
shapeForPosition: point
	"Return the shape located that contains point"
	 ^ trachelCanvas shapeForPosition: point! !

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/25/2013 09:28'!
signalUpdate
	self changed! !

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/25/2013 08:39'!
step
	self changed! !

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/23/2013 18:59'!
stepTime
	"Answer the desired time between steps in milliseconds. This default implementation requests that the 'step' method be called once every second."

	^ 20! !

!TRMorph methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/18/2013 23:20'!
wantsSteps
	^ trachelCanvas hasAnimation ! !

Object subclass: #TRCanvas
	instanceVariableNames: 'canvas shapes extent animations morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Trachel'!

!TRCanvas methodsFor: 'animations' stamp: 'AlexandreBergel 12/23/2013 13:52'!
addAnimation: anAnimation
	animations add: anAnimation.
	anAnimation start! !

!TRCanvas methodsFor: 'building' stamp: 'AlexandreBergel 12/25/2013 09:25'!
addShape: shape
	shapes add: shape.
	shape canvas: self! !

!TRCanvas methodsFor: 'events' stamp: 'AlexandreBergel 12/15/2013 19:46'!
announce: anEvent

	"Do it later"! !

!TRCanvas methodsFor: 'accessing' stamp: 'AlexandreBergel 12/25/2013 09:26'!
athensCanvas
	^ canvas! !

!TRCanvas methodsFor: 'building' stamp: 'AlexandreBergel 12/24/2013 18:44'!
buildCircleFrom: aPoint to: anotherPoint color: aColor
	| shape |
	shape := TREllipseShape new.
	shape from: aPoint to: anotherPoint color: aColor.
	self addShape: shape.
	^ shape! !

!TRCanvas methodsFor: 'building' stamp: 'AlexandreBergel 12/24/2013 18:35'!
buildLineFrom: aPoint to: anotherPoint color: aColor
	|  shape |
	shape := TRLineShape new.
	shape from: aPoint to: anotherPoint color: aColor.
	self addShape: shape.
	^ shape! !

!TRCanvas methodsFor: 'building' stamp: 'AlexandreBergel 12/24/2013 18:34'!
buildRectangle: aRectangle color: aColor
	| shape |
	shape := TRBoxShape new.
	shape fromRectangle: aRectangle color: aColor.
	self addShape: shape.
	^ shape! !

!TRCanvas methodsFor: 'accessing' stamp: 'AlexandreBergel 12/14/2013 10:30'!
extent
	^ extent! !

!TRCanvas methodsFor: 'animations' stamp: 'AlexandreBergel 12/18/2013 18:25'!
hasAnimation
	^ animations notEmpty! !

!TRCanvas methodsFor: 'initialization' stamp: 'AlexandreBergel 12/18/2013 18:24'!
initialize
	super initialize.
	extent := 500 @ 500.
	canvas := AthensCairoSurface extent: extent.
	shapes := OrderedCollection new.
	animations := OrderedCollection new! !

!TRCanvas methodsFor: 'animations' stamp: 'AlexandreBergel 12/18/2013 18:24'!
numberOfAnimations
	^ animations size! !

!TRCanvas methodsFor: 'accessing' stamp: 'AlexandreBergel 12/16/2013 11:24'!
numberOfShapes
	^ shapes size! !

!TRCanvas methodsFor: 'instance creation' stamp: 'AlexandreBergel 12/25/2013 08:31'!
open 
	morph := TRMorph new 
		extent: canvas extent;
		canvas: self. 
	morph openInWindow! !

!TRCanvas methodsFor: 'animations' stamp: 'AlexandreBergel 12/23/2013 14:06'!
playAnimations
	| shouldClean |
	shouldClean := false.
	animations do: [ :animation | 
		animation refresh. 
		animation hasCompleted ifTrue: [ shouldClean := true ] ].
	
	shouldClean ifTrue: [ 
		animations := animations reject: [ :animation | animation hasCompleted ] ].! !

!TRCanvas methodsFor: 'accessing' stamp: 'AlexandreBergel 12/15/2013 19:10'!
shapeForPosition: position
	shapes do: [ :s | 
		(s includesPoint: position) ifTrue: [ ^ s ] ].
	^ self! !

!TRCanvas methodsFor: 'accessing' stamp: 'AlexandreBergel 12/14/2013 10:22'!
shapes
	"Return the list of shapes"
	^ shapes! !

!TRCanvas methodsFor: 'updating' stamp: 'AlexandreBergel 12/25/2013 09:28'!
signalUpdate
	morph changed! !

Object subclass: #TRCanvasExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Trachel'!

!TRCanvasExample methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/18/2013 18:46'!
animationTest
	"
	self new animationTest
	"
	| canvas circle |
	canvas := TRCanvas new.
	circle := canvas buildCircleFrom: 50 @ 50 to: 100 @ 80 color: (Color purple alpha: 0.2).
	canvas addAnimation: (RTLinearMove to: 100 @ 100 during: 2000 on: circle). 
	canvas open! !

!TRCanvasExample methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/24/2013 18:57'!
circle
	"
	self new circle
	"
	| c  |
	c := TRCanvas new.
	c buildRectangle: (50 @ 50 corner: 80 @ 80) color: (Color blue alpha: 0.2).

	100 to: 200 by: 20 do: [ :i |
		 c buildCircleFrom: 50 @ 50 to: i @ 100 color: (Color red alpha: 0.1).
	].
	c open.
	
! !

!TRCanvasExample methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/14/2013 17:49'!
rec1
	"
	self new rec1
	"

	| c |
	c := TRCanvas new.
	c buildRectangle: ((50 @ 50) extent: (150 @ 75)) color: Color red.
	c buildRectangle: ((80 @ 80) extent: (150 @ 75)) color: Color lightGreen.
	c buildLineFrom: 50 @ 50 to: 80 @ 80 color: Color lightGreen.
	c open! !

Object subclass: #TRShape
	instanceVariableNames: 'canvas color path strokePaint position announcer element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Trachel'!

TRShape subclass: #TRAbstractBoxShape
	instanceVariableNames: 'rectangle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Trachel'!

!TRAbstractBoxShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/25/2013 09:27'!
computePath
	canvas ifNil: [ ^ self ].
	path := self athensCanvas
		createPath: [ :builder | 
			builder
				absolute;
				moveTo: rectangle topLeft;
				lineTo: rectangle topRight;
				lineTo: rectangle bottomRight;
				lineTo: rectangle bottomLeft;
				lineTo: rectangle topLeft ]! !

!TRAbstractBoxShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/24/2013 15:59'!
extent
	^ self rectangle extent! !

!TRAbstractBoxShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/24/2013 16:59'!
extent: anExtent
	| center |
	center := rectangle center.
	rectangle := (center - (anExtent / 2)) extent: anExtent.
	self resetPath! !

!TRAbstractBoxShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/16/2013 16:52'!
from: aPoint to: anotherPoint 
	
	self fromRectangle: (aPoint corner: anotherPoint)! !

!TRAbstractBoxShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/16/2013 16:52'!
from: aPoint to: anotherPoint color: aColor
	self from: aPoint to: anotherPoint.
	self color: aColor.! !

!TRAbstractBoxShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/24/2013 16:59'!
fromRectangle: r
	rectangle := r.
	self resetPath! !

!TRAbstractBoxShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/16/2013 16:52'!
fromRectangle: r color: aColor
	self fromRectangle: r.
	self color: aColor! !

!TRAbstractBoxShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/23/2013 23:41'!
height
	^ rectangle height! !

!TRAbstractBoxShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/16/2013 16:52'!
includesPoint: aPoint
	"We could aternatively translate rectangle by position"
	^ rectangle containsPoint: (aPoint - position)! !

!TRAbstractBoxShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/24/2013 15:48'!
rectangle
	^ rectangle! !

!TRAbstractBoxShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/24/2013 18:46'!
rectangle: r
	self fromRectangle: r! !

!TRAbstractBoxShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/23/2013 23:40'!
width
	^ rectangle width! !

TRAbstractBoxShape subclass: #TRBorderBoxShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Trachel'!

!TRBorderBoxShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/24/2013 17:04'!
drawOn: athensCanvas

	athensCanvas pathTransform restoreAfter: [
		athensCanvas pathTransform 
			translateBy: position.

		athensCanvas
			setStrokePaint: strokePaint;
			drawShape: self path ]! !

TRAbstractBoxShape subclass: #TRBoxShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Trachel'!

!TRBoxShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/24/2013 17:04'!
drawOn: athensCanvas

	athensCanvas pathTransform restoreAfter: [
		athensCanvas pathTransform 
			translateBy: position.

		athensCanvas
			setPaint: color;
			drawShape: self path ]! !

TRAbstractBoxShape subclass: #TREllipseShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Trachel'!

!TREllipseShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/25/2013 09:27'!
computePath
	canvas ifNil: [ ^ self ].
	path := self athensCanvas
				createPath: [ :builder | 
					builder
						absolute;
						moveTo: 0 @ 1;
						ccwArcTo: 1.0 @ 0.0 angle: 90 degreesToRadians;
						ccwArcTo: 0.0 @ -1.0 angle: 90 degreesToRadians;
						ccwArcTo: -1.0 @ 0.0 angle: 90 degreesToRadians;
						ccwArcTo: 0 @ 1.0 angle: 90 degreesToRadians ]
"	path := canvas
		cacheAt: self
		ifAbsentPut: [ 
			canvas
				createPath: [ :builder | 
					builder
						absolute;
						moveTo: 0 @ 1;
						ccwArcTo: 1.0 @ 0.0 angle: 90 degreesToRadians;
						ccwArcTo: 0.0 @ -1.0 angle: 90 degreesToRadians;
						ccwArcTo: -1.0 @ 0.0 angle: 90 degreesToRadians;
						ccwArcTo: 0 @ 1.0 angle: 90 degreesToRadians ] ]"! !

!TREllipseShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/24/2013 18:57'!
drawOn: athensCanvas

	athensCanvas pathTransform restoreAfter: [
		athensCanvas pathTransform 
			translateBy: rectangle center;
			scaleBy: rectangle extent / 2.

		athensCanvas
			setPaint: color;
			drawShape: self path.
			
"		athensCanvas
			setStrokePaint: strokePaint;
			drawShape: path
"		]! !

!TREllipseShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/24/2013 18:44'!
from: aPoint to: anotherPoint color: aColor
	rectangle := aPoint corner: anotherPoint.
	position := rectangle center.
	self strokePaint: aColor.
	self color: aColor! !

!TREllipseShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/24/2013 18:45'!
includesPoint: aPoint
	"We could aternatively translate rectangle by position"
	^ rectangle containsPoint: (aPoint)! !

TRShape subclass: #TRLineShape
	instanceVariableNames: 'from to'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Trachel'!

!TRLineShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/26/2013 10:35'!
computePath
	path := self athensCanvas
		createPath: [ :builder | 
			builder
				absolute;
				moveTo: from;
				lineTo: to ]! !

!TRLineShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/16/2013 19:18'!
from
	"Return a point"
	^ from! !

!TRLineShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/16/2013 19:18'!
from: aPoint
	from := aPoint! !

!TRLineShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/24/2013 16:33'!
from: aPoint to: anotherPoint
	from := aPoint.
	to := anotherPoint.
! !

!TRLineShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/14/2013 18:46'!
from: aPoint to: anotherPoint color: aColor

	self from: aPoint to: anotherPoint.
	self strokePaint: aColor.
	self color: aColor! !

!TRLineShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/15/2013 19:16'!
includesPoint: aPoint
	^ aPoint onLineFrom: from to: to within: 3! !

!TRLineShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/16/2013 19:18'!
to
	"Return a point"
	^ to! !

!TRLineShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/17/2013 16:52'!
to: aPoint
	to := aPoint! !

!TRShape methodsFor: 'events' stamp: 'AlexandreBergel 12/15/2013 23:11'!
announce: anEvent
	self announcer announce: anEvent! !

!TRShape methodsFor: 'events' stamp: 'AlexandreBergel 12/15/2013 19:23'!
announcer
	announcer isNil ifTrue: [ announcer := Announcer new ].
	^ announcer! !

!TRShape methodsFor: 'events' stamp: 'AlexandreBergel 12/16/2013 09:44'!
announcer: anAnnouncer
	announcer := anAnnouncer! !

!TRShape methodsFor: 'accessing' stamp: 'AlexandreBergel 12/25/2013 09:26'!
athensCanvas
	^ self canvas athensCanvas! !

!TRShape methodsFor: 'accessing' stamp: 'AlexandreBergel 12/25/2013 09:25'!
canvas
	"Return a Trachel Canvas"
	^ canvas! !

!TRShape methodsFor: 'accessing' stamp: 'AlexandreBergel 12/14/2013 17:47'!
canvas: aSurface
	"aCanvas is a AthensCairoSurface"
	canvas := aSurface! !

!TRShape methodsFor: 'accessing' stamp: 'AlexandreBergel 12/14/2013 10:10'!
color
	
	^ color! !

!TRShape methodsFor: 'accessing' stamp: 'AlexandreBergel 12/14/2013 10:10'!
color: aColor
	
	color := aColor! !

!TRShape methodsFor: 'hooks' stamp: 'AlexandreBergel 12/24/2013 17:02'!
computePath
	self subclassResponsibility! !

!TRShape methodsFor: 'drawing' stamp: 'AlexandreBergel 12/24/2013 17:04'!
drawOn: athensCanvas

	athensCanvas pathTransform restoreAfter: [
		athensCanvas pathTransform 
			translateBy: position.

		athensCanvas
			setPaint: color;
			drawShape: self path.
			
		athensCanvas
			setStrokePaint: strokePaint;
			drawShape: self path  ]! !

!TRShape methodsFor: 'accessing' stamp: 'AlexandreBergel 12/16/2013 22:52'!
element
	"A shape has a reference to an object, typically the object odel that the trachel shape represents"
	^ element ! !

!TRShape methodsFor: 'accessing' stamp: 'AlexandreBergel 12/16/2013 22:52'!
element: anObject
	"anObject could be any kind of object. A shape has a reference to an object, typically the object odel that the trachel shape represents"
	element := anObject! !

!TRShape methodsFor: 'testing' stamp: 'AlexandreBergel 12/15/2013 19:12'!
includesPoint: aPoint
	^ false! !

!TRShape methodsFor: 'initialization' stamp: 'AlexandreBergel 12/24/2013 18:56'!
initialize
	super initialize.
	color := Color gray.
	strokePaint := Color black.	
	position := 0 @ 0! !

!TRShape methodsFor: 'events' stamp: 'AlexandreBergel 12/15/2013 23:12'!
on: event do: aBlock
	self announcer on: event do: aBlock! !

!TRShape methodsFor: 'accessing' stamp: 'AlexandreBergel 12/24/2013 17:02'!
path
	path ifNil: [ self computePath ].
	^ path! !

!TRShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 12/24/2013 17:07'!
resetPath
	path := nil! !

!TRShape methodsFor: 'actions' stamp: 'AlexandreBergel 12/25/2013 08:43'!
signalUpdate
	canvas signalUpdate! !

!TRShape methodsFor: 'accessing' stamp: 'AlexandreBergel 12/14/2013 10:48'!
strokePaint
	"Return the color of the border line"
	^ strokePaint! !

!TRShape methodsFor: 'accessing' stamp: 'AlexandreBergel 12/14/2013 10:49'!
strokePaint: aColor
	"set the color of the border line"
	strokePaint := aColor! !

!TRShape methodsFor: 'actions' stamp: 'AlexandreBergel 12/14/2013 12:46'!
translateBy: aPoint
	"We should not have this..."
	self translateTo: (position + aPoint)! !

!TRShape methodsFor: 'actions' stamp: 'AlexandreBergel 12/16/2013 22:37'!
translateTo: aPoint
	position := aPoint! !
